<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.17 Update #3                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2013 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.98.131123-190401                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Templates
 * @copyright (C) 2002-2013 Esselbach Internet Solutions
 */
class templates
{

	function gettemplate( $var, $var2 )
	{
		global $database, $insert;
		$query = $database -> dbquery( "SELECT template_html, template_php FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name = '" . $var . "' AND template_set = '" . $var2 . "'" );
		list( $template_html, $template_php ) = $database -> dbrow( $query );
		$this_template = "global \$insert;\n";

		if( $template_php )
		{
			$this_template .= $template_php . "\n";
		}

		$this_template .= "\$EST_TEMPLATE = <<<TEMPLATE\n" . $template_html . "\nTEMPLATE;\n";
		eval( $this_template );
		return $EST_TEMPLATE;
	}

	function preparetemplates( $var, $var2 )
	{
		global $database, $preferences;
		$template_html = array();
		$template_php = array();
		$query = $database -> dbquery( "SELECT template_name, template_html, template_php FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name IN (" . $var . ") AND template_set = '" . $var2 . "'" );

		while( list( $template_name, $template_html, $template_php ) = $database -> dbrow( $query ) )
		{
			if ( $preferences[ 'website_mod_rewrite' ] )
			{
				$template_html = str_replace( array( "index.php{\$insert['param_ct']}", "contentteller{\$insert['param_ext']}{\$insert['param_ct']}", "{\$insert['param_ext']}{\$insert['param_ct']}" ), "", $template_html );
			}
			elseif ( $preferences[ 'website_forcetype' ] )
			{
				$template_html = str_replace( "index.php{\$insert['param_ct']}", "contentteller{\$insert['param_ext']}{\$insert['param_ct']}", $template_html );
			}
			elseif ( $preferences[ 'website_basic_rewrite' ] )
			{
				$template_html = str_replace( "index.php{\$insert['param_ct']}", "?{\$insert['param_ct']}", $template_html );
			}

			if( ( $template_name == "site_header" or $template_name == "site_header_alt" ) and ( $preferences[ 'website_rtl' ] ) )
			{
				$template_html = str_replace( "<html xmlns=\"http://www.w3.org/1999/xhtml\">", "<html xmlns=\"http://www.w3.org/1999/xhtml\" dir=\"RTL\">", $template_html );
			}

			( $template_html ) ? $template_data[ $template_name . '_html' ] = $template_html : $template_data[ $template_name . '_html' ] = "" ;
			( $template_php ) ? $template_data[ $template_name . '_php' ] = $template_php : $template_data[ $template_name . '_php' ] = "" ;
		}

		return $template_data;
	}

	function verifytemplate( $var, $var2 )
	{
		define( "PIGS_ARE_FLYING", false ); // No flying pigs here
		@ini_set( "display_errors", "on" );
		error_reporting( E_ALL );

		ob_start();
		$this_template = "global \$insert;\n";

		if( $var2 )
		{
			$this_template .= "if (PIGS_ARE_FLYING) { ". stripslashes( $var2 ) . " }\n";
		}

		$this_template .= "\$EST_TEMPLATE = <<<TEMPLATE\n" . stripslashes( $var ) . "\nTEMPLATE;\n";
		eval( $this_template );
		$output = ob_get_contents();
		ob_end_clean();

		if( ( preg_match( "/Parse error/i", $output ) ) and( preg_match( "/d code/i", $output ) ) )
		{
			return $output;
		}
		else
		{
			return 0;
		}
	}

	function initgzip()
	{
		global $preferences, $database, $system, $user;

		if( ( extension_loaded( "zlib" ) ) and( !ini_get( "output_handler" ) ) and( !ini_get( "zlib.output_compression" ) ) and( $preferences[ 'website_gzip' ] ) )
		{
			$gzip = 1;
		}
		else
		{
			$gzip = 0;
		}

		if( ( $preferences[ 'website_cache' ] ) and( !count( $_POST ) ) and( !$user[ 'user_status' ] ) )
		{
			$cache_query = $system -> hashcache();

			if( $user[ 'user_nocookie' ] )
			{
			    $cache_query = "NOC" . substr( $cache_query, 0, 37 );
			}

			$current_date = mktime();

			if( $preferences[ 'website_cache_filesystem' ] )
			{
				if( file_exists( "cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html" ) )
				{
					$cachefile = file( "cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html" );
					$cacheexpire = explode( " ", $cachefile[ 0 ] );

					if( $cacheexpire[ 1 ] > $current_date )
					{
						if ( $gzip )
						{
							ob_start( "ob_gzhandler" );
						}

						for( $c = 1; $c < count( $cachefile ); $c++ )
						{
							echo $cachefile[ $c ];
						}

						exit;
					}
					else
					{
						@unlink( "cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html" );
						ob_start();
						$preferences[ 'website_cache_running' ] = 1;
					}
				}
				else
				{
					ob_start();
					$preferences[ 'website_cache_running' ] = 1;
				}
			}
			else
			{
				$query = $database -> dbquery( "SELECT cache_data FROM " . DB_PREFIX . "esselbach_ct_cache WHERE cache_website = '" . $preferences[ 'current_website' ] . "' AND cache_set = '" . $preferences[ 'current_theme' ] . "' AND cache_query = '" . $cache_query . "' AND cache_expire > ('" . $current_date . "')" );

				if( $database -> dbrows( $query ) )
				{
					list( $cache_data ) = $database -> dbrow( $query );
					if ( $gzip )
					{
						ob_start( "ob_gzhandler" );
					}
					echo $cache_data;
					exit;
				}
				else
				{
					$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_cache WHERE cache_expire < ('" . $current_date . "')" );
					ob_start();
					$preferences[ 'website_cache_running' ] = 1;
				}
			}
		}
		else
		{
			if ( $gzip )
			{
				ob_start( "ob_gzhandler" );
			}
			if( $preferences[ 'website_tidy'] )
			{
				if(function_exists( "ob_tidyhandler" ) )
				{
					ob_start( "ob_tidyhandler" );
				}
			}
		}
	}

	function writecache()
	{
		global $preferences, $database, $system, $user;
		if( ( $preferences[ 'website_cache' ] ) and( !count( $_POST ) ) and( !$user[ 'user_status' ] ) )
		{
			$cache_query = $system -> hashcache();
			if( $user[ 'user_nocookie' ] )
			{
			    $cache_query = "NOC" . substr( $cache_query, 0, 37 );
			}

			$cache_expire = mktime() + $preferences[ 'website_cache_expire' ];
			$cache_data = ob_get_contents();

			if( $cache_data )
			{
				ob_end_clean();
			}

			if( !preg_match( "/input_security_hash/i", $cache_data ) )
			{
				if( $preferences[ 'website_tidy'] )
				{
					if (function_exists( "tidy_parse_string" ) )
					{
						$cache_data = tidy_parse_string( $cache_data );
						tidy_clean_repair( $cache_data );
					}
				}
				if( $preferences[ 'website_cache_filesystem' ] )
				{
					$cachefile = @fopen( "cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html", "w" ) or die( "Error: Can't write cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html cache file" );

					if( flock( $cachefile, 2 ) )
					{
						fputs( $cachefile, "<!-- " . $cache_expire . " -->\n" . $cache_data );
					}

					flock( $cachefile, 3 );
					fclose( $cachefile );
					@chmod( "cache/" . $preferences[ 'current_website' ] . "_" . $preferences[ 'current_theme' ] . "_" . $cache_query . ".html", 0777 );
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_cache (cache_id, cache_query, cache_website, cache_set, cache_data, cache_expire) VALUES (NULL, '" . $cache_query . "', '" . $preferences[ 'current_website' ] . "',  '" . $preferences[ 'current_theme' ] . "', '" . $database -> dbescape( $cache_data ) . "', '" . $cache_expire . "')" );
				}
			}

			ob_start( "ob_gzhandler" );
			echo $cache_data;
		}
	}

	function preparetemplates2( $var, $var2 )
	{
		global $database;
		$var = explode( ",", $var );
		$template_data = array();

		for( $template = 0; $template < count( $var ); $template++ )
		{
			$query = $database -> dbquery( "SELECT template_html, template_php FROM " . DB_PREFIX . "esselbach_ct_templates WHERE template_name = '$var[$template]' AND template_set = '$var2'" );
			list( $template_html, $template_php ) = $database -> dbrow( $query );
			( $template_html ) ? $template_data[ $var[ $template ] . '_html' ] = $template_html : $template_data[ $var[ $template ] . '_html' ] = "" ;
			( $template_php ) ? $template_data[ $var[ $template ] . '_php' ] = $template_php : $template_data[ $var[ $template ] . '_php' ] = "" ;
		}

		return $template_data;
	}

	function exectemplate( $var, $var2, $insert )
	{
		global $preferences;

		$this_template = "";
		$EST_TEMPLATE = "";

		if( $var2 )
		{
			$this_template .= $var2 . "\n";
		}

		$this_template .= "\$EST_TEMPLATE = <<<TEMPLATE\n" . $var . "\nTEMPLATE;\n";
		@eval( $this_template );

		if( $preferences[ 'website_seo_hyphens' ] )
		{
			preg_match_all("/\<a href=\"(.*)\"/Ui", $EST_TEMPLATE, $matches, PREG_SET_ORDER);
			foreach( $matches as $match )
			{
				if( !preg_match( "/http:\/\//i" , $match[ 1 ] ) or preg_match( "/". str_replace( "/", "\/", $preferences[ 'website_url' ] ) . "/i" , $match[ 1 ] ) )
				{
					$EST_TEMPLATE = str_replace( $match[ 1 ], str_replace( "_", "-", $match[ 1 ] ), $EST_TEMPLATE );
				}
			}
		}

		return $EST_TEMPLATE;
	}

	function prepareblocks( $var, $var2, $var3, $var4, $var5, $var6, $var7 )
	{
		global $config, $database, $uwrapper, $system, $preferences, $templates, $user;
		$current = mktime();
		$datastore = array();
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_expire < '" . $current . "'" );
		$query = $database -> dbquery( "SELECT datastore_query, datastore_data FROM " . DB_PREFIX . "esselbach_ct_datastore WHERE datastore_website = '" . $preferences[ 'current_website' ] . "'" );

		while( list( $datastore_query, $datastore_data ) = $database -> dbrow( $query ) )
		{
			$datastore[ $datastore_query ] = $datastore_data;
		}

		if( $var7 )
		{
			$query = $database -> dbquery( "SELECT block_id, block_name, block_html, block_php, block_externalphp, block_switch, block_category, block_appearance FROM " . DB_PREFIX . "esselbach_ct_blocks WHERE block_id IN(" . $var7 . ") ORDER BY block_position" );
		}
		else
		{
			$query = $database -> dbquery( "SELECT block_id, block_name, block_html, block_php, block_externalphp, block_switch, block_category, block_appearance FROM " . DB_PREFIX . "esselbach_ct_blocks WHERE block_active = '1' AND (block_website = '0' OR block_website = '" . $preferences[ 'current_website' ] . "') ORDER BY block_position" );
		}
		$blocks = array();
		$blocks[ 1 ] = "";

		while( list( $block_id, $block_name, $block_html, $block_php, $block_externalphp, $block_switch, $block_category, $block_appearance ) = $database -> dbrow( $query ) )
		{
			if( !$block_category )
			{
				$block_category = 1;
			}

			$insert[ 'block_id' ] = "block" . md5( "block" . $block_id );

			if( !isset( $blocks[ $block_category ] ) )
			{
				$blocks[ $block_category ] = "";
			}

			if( $block_switch == 1 )
			{
				if( file_exists( "blocks/" . $block_externalphp ) )
				{
					ob_start();
					@include( "blocks/" . $block_externalphp );
					$insert[ 'block_content' ] = ob_get_contents();
					ob_end_clean();
					$insert[ 'block_name' ] = $block_name;
				}
			}
			else
			{
				$this_block = "";

				if( $block_php )
				{
					$this_block .= $block_php . "\n";
				}

				$this_block .= "\$EST_BLOCK = <<<THISBLOCK\n".$block_html."\nTHISBLOCK;
				\n";
				@eval( $this_block );
				$insert[ 'block_name' ] = $block_name;
				$insert[ 'block_content' ] = $EST_BLOCK;
			}

			if( $block_appearance == 1 and !$user[ 'user_nocookie' ] )
			{
				$blocks[ $block_category ] .= $templates -> exectemplate( $var3, $var4, $insert );
			}
			elseif( $block_appearance == 2 )
			{
				$blocks[ $block_category ] .= $templates -> exectemplate( $var5, $var6, $insert );
			}
			else
			{
				$blocks[ $block_category ] .= $templates -> exectemplate( $var, $var2, $insert );
			}
		}

		return $blocks;
	}
}
?>